# EvMigrationUtil

## Introduction

A helper library to help manage data creation in migrations. E.g. creating pages and templates to go with your new feature

## Setup

Not much setup required

	composer require evoluted/migration-util

## Using the Utility

Out the box the migration utily comes with a copy of basic functions. To initial for a model use the following:

	$PageMigrationUtil = MigrationUtil::init('EvCore.Page');

You can then call methods like:

	$PageMigrationUtil->createOnce(
		['internal_title' => 'venue_index'],
		[
			'title' => 'All Venues',
			'internal_title' => 'venue_index',
			'body' => '....',
			...
		]
	);

This helper method will only create the record if it doesn't already exist

## Custom Model Migration Utilities

In the cases of complex plugins you may want to create a helper with more specific helper methods. In this case you want to create a class like this

	<?php

	App::uses('BaseMigrationModelUtil', 'EvMigrationUtil.Lib');

	class PageMigrationModelUtil extends BaseMigrationModelUtil {

	/**
	 * YOUR CUSTOM HELPERS HERE
	 * /
		public function createByInternalTitle($internalTitle....) {
			...
		}

For Plugin model save in

	[PLUGIN]/Lib/MigrationUtil/[Model]MigrationModelUtil.php

For App model save in

	app/Lib/MigrationUtil/[Model]MigrationModelUtil.php

For overriden plugin model

	app/Lib/MigrationUtil/[PluginName][Model]MigrationModelUtil.php

This still is initialised in the same way and it will find the overrides

	$PageMigrationUtil = new MigrationUtil('EvCore.Page');